"use strict";

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

const Promise = require('bluebird');

const mapValues = require('lodash/mapValues');

const {
  ORGANIZATIONS_MEMBERS,
  USERS_DATA,
  USERS_BANNED_FLAG
} = require('../../constants');

const redisKey = require('../key');

const JSONParse = d => JSON.parse(d);

async function getMemberData(organizationMemberId) {
  const [,, userId] = organizationMemberId.split('!');
  const organization = await this.redis.hgetall(organizationMemberId);
  const banned = await this.redis.hget(redisKey(userId, USERS_DATA), USERS_BANNED_FLAG);
  return mapValues(_objectSpread(_objectSpread({}, organization), {}, {
    banned
  }), JSONParse);
}

async function getOrganizationMembers(organizationId) {
  const {
    redis
  } = this;
  const organizationMembersIds = (await redis.zrange(redisKey(organizationId, ORGANIZATIONS_MEMBERS), 0, -1)) || [];
  const organizationMembersJobs = organizationMembersIds.map(getMemberData, this);
  return Promise.all(organizationMembersJobs);
}

module.exports = getOrganizationMembers;
module.exports.getMemberData = getMemberData;