"use strict";

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

const generateEmail = require('../challenges/email/generate.js');

const {
  organizationInvite,
  inviteId,
  TOKEN_METADATA_FIELD_CONTEXT,
  TOKEN_METADATA_FIELD_SENDED_AT,
  USERS_ACTION_ORGANIZATION_INVITE,
  TOKEN_METADATA_FIELD_METADATA
} = require('../../constants.js');

module.exports = async function sendInviteMail(params, action = USERS_ACTION_ORGANIZATION_INVITE) {
  const {
    redis,
    tokenManager
  } = this;
  const {
    email,
    ctx
  } = params;
  const now = Date.now();
  const token = await tokenManager.create({
    action,
    id: inviteId(ctx.organizationId, email),
    regenerate: true,
    metadata: {
      [TOKEN_METADATA_FIELD_METADATA]: {
        permissions: ctx.permissions
      },
      [TOKEN_METADATA_FIELD_CONTEXT]: ctx,
      [TOKEN_METADATA_FIELD_SENDED_AT]: now
    }
  });
  const res = await generateEmail.call(this, email, action, _objectSpread(_objectSpread({}, ctx), {}, {
    token
  }), {
    wait: true,
    send: true
  });

  if (res.err) {
    this.log.error(res, 'send invite mail result');
  }

  if (action === USERS_ACTION_ORGANIZATION_INVITE) {
    await redis.sadd(organizationInvite(ctx.organizationId), email);
  }
};